searchData={"items":[{"type":"module","title":"Mojo","doc":"Implements interface functions using the Trie module under-the-hood.","ref":"Mojo.html"},{"type":"function","title":"Mojo.create_dict/0","doc":"Creates an empty dictionary.\n\nReturns a `%Trie{}`.","ref":"Mojo.html#create_dict/0"},{"type":"function","title":"Examples - Mojo.create_dict/0","doc":"iex> Mojo.create_dict()\n  %Trie{root: %TrieNode{children: %{}, is_terminal: false}}","ref":"Mojo.html#create_dict/0-examples"},{"type":"function","title":"Mojo.in_dict?/2","doc":"Checks if a word exists in a dictionary.\n\nReturns an `Atom` representing `true`, or `false`.","ref":"Mojo.html#in_dict?/2"},{"type":"function","title":"Examples - Mojo.in_dict?/2","doc":"iex> dict = Mojo.create_dict()\n  iex> dict = Mojo.update_dict(dict, \"word3\")\n  iex> Mojo.in_dict?(dict, \"word3\")\n  true \n  iex> Mojo.in_dict?(dict, \"word4\")\n  false","ref":"Mojo.html#in_dict?/2-examples"},{"type":"function","title":"Mojo.parse/2","doc":"Maps any error in a passage with their closest matches in the dictionary.\n\nReturns a `%{}`.","ref":"Mojo.html#parse/2"},{"type":"function","title":"Examples - Mojo.parse/2","doc":"iex> dict = Mojo.create_dict()\n  iex> dict = Mojo.update_dict(dict, [\"word1\", \"word2\", \"word3\"])\n  iex> Mojo.parse(dict, [\"werd\"])\n  %{\"werd\" => [\"word1\", \"word2\", \"word3\"]}","ref":"Mojo.html#parse/2-examples"},{"type":"function","title":"Mojo.prefix_matches/2","doc":"Returns all words that match a given prefix.\n\nReturns a `List`.","ref":"Mojo.html#prefix_matches/2"},{"type":"function","title":"Examples - Mojo.prefix_matches/2","doc":"iex> dict = Mojo.create_dict()\n  iex> dict = Mojo.update_dict(dict, [\"word1\", \"word2\", \"word3\"])\n  iex> Mojo.prefix_matches(dict, \"word\")\n  [\"word1\", \"word2\", \"word3\"]","ref":"Mojo.html#prefix_matches/2-examples"},{"type":"function","title":"Mojo.update_dict/2","doc":"Updates a dictionary given a list of words, or a single word.\n\nReturns an updated `%Trie{}`.","ref":"Mojo.html#update_dict/2"},{"type":"function","title":"Examples - Mojo.update_dict/2","doc":"iex> dict = Mojo.create_dict()\n  iex> updated_dict = Mojo.update_dict(dict, [\"word1\", \"word2\"])\n  iex> updated_dict\n  %Trie{\n    root: %TrieNode{\n      children: %{\n        \"w\" => %TrieNode{\n          children: %{\n            \"o\" => %TrieNode{\n              children: %{\n                \"r\" => %TrieNode{\n                  children: %{\n                    \"d\" => %TrieNode{\n                      children: %{\n                        \"1\" => %TrieNode{children: %{}, is_terminal: true},\n                        \"2\" => %TrieNode{children: %{}, is_terminal: true}\n                      },\n                      is_terminal: false\n                    }\n                  },\n                  is_terminal: false\n                }\n              },\n              is_terminal: false\n            }\n          },\n          is_terminal: false\n        }\n      },\n      is_terminal: false\n    }\n  }\n\n  iex> dict = Mojo.create_dict()\n  iex> updated_dict = Mojo.update_dict(dict, \"word3\")\n  iex> updated_dict\n  %Trie{\n    root: %TrieNode{\n      children: %{\n        \"w\" => %TrieNode{\n          children: %{\n            \"o\" => %TrieNode{\n              children: %{\n                \"r\" => %TrieNode{\n                  children: %{\n                    \"d\" => %TrieNode{\n                      children: %{\n                        \"3\" => %TrieNode{children: %{}, is_terminal: true}\n                      },\n                      is_terminal: false\n                    }\n                  },\n                  is_terminal: false\n                }\n              },\n              is_terminal: false\n            }\n          },\n          is_terminal: false\n        }\n      },\n      is_terminal: false\n    }\n  }","ref":"Mojo.html#update_dict/2-examples"},{"type":"module","title":"Trie","doc":"","ref":"Trie.html"},{"type":"function","title":"Trie.insert/2","doc":"","ref":"Trie.html#insert/2"},{"type":"function","title":"Trie.prefix_matches/2","doc":"","ref":"Trie.html#prefix_matches/2"},{"type":"function","title":"Trie.search/2","doc":"","ref":"Trie.html#search/2"},{"type":"module","title":"TrieNode","doc":"","ref":"TrieNode.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}